SystemOrganization addCategory: #'Pier-UpdateManager'!

PRWidget subclass: #PRInstallerWidget
	instanceVariableNames: 'installer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-UpdateManager'!

!PRInstallerWidget methodsFor: 'testing' stamp: 'dc 8/29/2008 18:57'!
checkForUpdate: packageName
	| currentPackage latestPackage |
	currentPackage := self currentPackage:packageName.
	latestPackage := self newestPackageNamed: packageName.
	^ (currentPackage version < latestPackage version)
		ifTrue: [latestPackage]
		ifFalse: [nil]! !

!PRInstallerWidget methodsFor: 'actions' stamp: 'dc 8/29/2008 18:50'!
currentPackage: packageName
	"returns the package named packageName which is currently installed"
	^ self installer installedPackageVersions
			detect: [:package | package name = packageName]! !

!PRInstallerWidget methodsFor: 'actions' stamp: 'dc 8/29/2008 19:06'!
handleExistingUpdate: aPackage 
	(self confirm: 'There is an update for ', aPackage name, ' (version ' , aPackage version printString, '). Do you want to upgrade?') ifTrue: [ self installPackage: aPackage ]! !

!PRInstallerWidget methodsFor: 'actions' stamp: 'dc 8/29/2008 18:52'!
installPackage: aPackage 
	self installer
		planToInstallPackage: aPackage;
		doInstall! !

!PRInstallerWidget methodsFor: 'accessing' stamp: 'dc 8/29/2008 18:14'!
installer
	^ installer ifNil: [installer := UGlobalInstaller new]! !

!PRInstallerWidget methodsFor: 'accessing' stamp: 'dc 8/29/2008 18:40'!
newestPackageNamed: aPackageName
	^ self installer universe newestPackageNamed: aPackageName ! !

!PRInstallerWidget methodsFor: 'actions' stamp: 'dc 8/29/2008 18:15'!
updateMap
	self installer requestPackageList ! !

PRInstallerWidget subclass: #PRPierUpdater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-UpdateManager'!

!PRPierUpdater class methodsFor: 'testing' stamp: 'dc 8/29/2008 18:15'!
isAbstract
	^ false! !

!PRPierUpdater class methodsFor: 'accessing' stamp: 'dc 8/29/2008 18:16'!
label
	^ 'Pier Updater'! !

!PRPierUpdater methodsFor: 'actions' stamp: 'dc 8/29/2008 18:59'!
checkForUpdates
	"self updateMap."
	(self checkForUpdate: self pierRootPackageName)
		ifNotNilDo: [:latestPackage | self handleExistingUpdate: latestPackage ]! !

!PRPierUpdater methodsFor: 'actions' stamp: 'dc 8/29/2008 18:32'!
pierRootPackageName
	^ 'Pier-Seaside'! !

!PRPierUpdater methodsFor: 'rendering' stamp: 'dc 8/29/2008 18:19'!
renderContentOn: html
	html form: [
		html button on: #checkForUpdates of: self]! !

PRInstallerWidget subclass: #PRPluginInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-UpdateManager'!

!PRPluginInstaller class methodsFor: 'testing' stamp: 'dc 8/29/2008 12:02'!
isAbstract
	^ false! !

!PRPluginInstaller class methodsFor: 'accessing' stamp: 'dc 8/29/2008 12:01'!
label
	^ 'Plugin installer'! !

!PRPluginInstaller class methodsFor: 'accessing' stamp: 'dc 8/29/2008 18:10'!
plugins
	^ #('Pier-Blog' 'Pier-Commands-RemoveChildren' 'Pier-Design'  'Pier-Documents'  'Pier-EditorEnh'  'Pier-Google'  'Pier-LightBox' 'Pier-Math' 'Pier-Randomizer' 'Pier-Security' 'Pier-Shout' 'Pier-TagCloud')! !

!PRPluginInstaller methodsFor: 'rendering' stamp: 'dc 8/29/2008 17:49'!
renderContentOn: html
	html form: [
		html table:  [
			self class plugins do: [:plugin |
				self
					renderPlugin: (self installer packageVersionsForPackage: plugin) last
					on: html]].
			html button on: #updateMap of: self.
		]! !

!PRPluginInstaller methodsFor: 'rendering' stamp: 'dc 8/29/2008 19:08'!
renderInstallButtonFor: aPlugin on: html 
	(self installer isPackageInstalled: aPlugin name) 
		ifTrue: [ (self  checkForUpdate: aPlugin name)
						ifNil: [html text: 'up to date']
						ifNotNilDo: [:latestPackage | html button
												callback: [self handleExistingUpdate: latestPackage];
												with: 'update']]
		ifFalse: 
			[ html button
				callback: [ self installPackage: aPlugin ];
				with: 'install' ]! !

!PRPluginInstaller methodsFor: 'rendering' stamp: 'dc 8/29/2008 17:59'!
renderPlugin: aPlugin on: html
	html tableRow: [
		html tableHeading: aPlugin name.
		html tableData: [self renderInstallButtonFor: aPlugin  on: html].
		html tableData: [html render: aPlugin description]]! !
